/* ===========================================================================
                           TTB Plugin Template(VC++)

                                 Main.cpp

   =========================================================================== */
#include "stdafx.h"

#include <vector>

#include "Main.h"
#include "MessageDef.h"

#include "MomoUtil.h"
#include "PopupWnd.h"

CComModule _Module;
BEGIN_OBJECT_MAP(ObjectMap)
END_OBJECT_MAP()

HINSTANCE g_hInstance;
std::vector<CPopupWnd> g_Popups;

int CreatePopupWnd(void);

// --------------------------------------------------------
//    vOC[hꂽƂɌĂ΂
// --------------------------------------------------------
BOOL Init(void)
{
	_Module.Init(ObjectMap, g_hInstance);
	PopupWndRegisterClass(g_hInstance);
	AtlAxWinInit();
	CreatePopupWnd();
	return TRUE;
}

// --------------------------------------------------------
//    vOCA[hꂽƂɌĂ΂
// --------------------------------------------------------
void Unload(void)
{
}

// --------------------------------------------------------
//    R}hsɌĂ΂
// --------------------------------------------------------
BOOL Execute(int CmdId, HWND hWnd)
{
	int index = CmdId / 10;
	CPopupWnd *popup = &g_Popups.at(index);

	switch (CmdId % 10) {
		case CMD_TOGGLE: {
			HWND hPopup = popup->GethWnd();
			if (hPopup) {
				if (GetForegroundWindow() == hPopup) {
					popup->Close(FALSE);
				} else {
					popup->Refresh();
					SetForegroundWindow(hPopup);
				}
			} else {
				popup->Show(SW_SHOW, FALSE);
				SetForegroundWindow(popup->GethWnd());
			}
			break;
		}

		case CMD_CHANGENOTIFY: {
			if (popup->CheckChanged()) {
				popup->Show(SW_SHOWNA, TRUE);
				popup->StartCloseTimer();
			}
			break;
		}
	}

	return TRUE;
}

// --------------------------------------------------------
//    O[otbNbZ[WĂ
// --------------------------------------------------------
void Hook(UINT Msg, DWORD wParam, DWORD lParam)
{
}

// --------------------------------------------------------
//    DLLMain
// --------------------------------------------------------
#ifdef __BORLANDC__
#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
	return 1;
}
#endif

#if _MSC_VER > 1000
BOOL WINAPI DllMain (HINSTANCE hInstance, DWORD fdwReason, LPVOID lpvReserved)
{
	if (fdwReason == DLL_PROCESS_ATTACH)
		g_hInstance = hInstance;
	return TRUE;
}
#endif

// --------------------------------------------------------
//    R}h̍쐬
// --------------------------------------------------------
void SetCommandData(PLUGIN_COMMAND_INFO *cmdInfo, int CommandID, const char *Name, const char *Caption, int DispMenu = dmHotKeyMenu, int TimerInterval = 0)
{
	cmdInfo->Name = (char *)malloc(strlen(Name) + 1);
	if (cmdInfo->Name != NULL)
		strcpy(cmdInfo->Name, Name);
	cmdInfo->Caption = (char *)malloc(strlen(Caption) + 1);
	if (cmdInfo->Caption != NULL)
		strcpy(cmdInfo->Caption, Caption);
	cmdInfo->CommandID = CommandID;
	cmdInfo->Attr = 0;
	cmdInfo->ResID = -1;
	cmdInfo->DispMenu = DispMenu;
	cmdInfo->TimerInterval = TimerInterval;
	cmdInfo->TimerCounter = 0;
}
void SetCommand(PLUGIN_INFO *plugin)
{
	char IniFileName[MAX_PATH];
	MomoUtil::GetIniFileName(g_hInstance, IniFileName);
	int nCount = 0;

	//ZNV擾
	char SectionNames[2048];
	GetPrivateProfileSectionNames(SectionNames, 2047, IniFileName);

	//ZNV擾
	char *pSec = SectionNames;
	while (pSec[0] != '\0') {
		nCount++;
		pSec += lstrlen(pSec) + 1;
	}
	if (!nCount) {
		nCount++;
		CopyMemory(SectionNames, "Default\0\0", 9);
	}

	PLUGIN_COMMAND_INFO *pCI = (PLUGIN_COMMAND_INFO *)malloc(sizeof(PLUGIN_COMMAND_INFO) * nCount * COMMAND_COUNT);
	plugin->CommandCount = nCount * COMMAND_COUNT;
	plugin->Commands = pCI;

	//R}ho^
	pSec = SectionNames;
	int i = 0;
	while (pSec[0] != '\0') {
		char title[1024], buf[1024];
		CPopupWnd popup(g_hInstance, pSec);
		popup.GetTitle(title);
		wsprintf(buf, "%s\", title);
		SetCommandData(pCI++, i * 10 + CMD_TOGGLE, pSec, buf, dmHotKeyMenu | dmToolMenu);
		wsprintf(buf, "%s̃t@C`FbN", title);
		SetCommandData(pCI++, i * 10 + CMD_CHANGENOTIFY, pSec, buf, dmNone, 500);
		pSec += lstrlen(pSec) + 1;
		i++;
	}
}

// --------------------------------------------------------
//    PopupWndNX̃CX^X쐬
// --------------------------------------------------------
int CreatePopupWnd(void)
{
	char IniFileName[MAX_PATH];
	MomoUtil::GetIniFileName(g_hInstance, IniFileName);
	int nCount = 0;

	//ZNV擾
	char SectionNames[2048];
	GetPrivateProfileSectionNames(SectionNames, 2047, IniFileName);

	//CX^X
	char *pSec = SectionNames;
	while (pSec[0] != '\0') {
		nCount++;
		g_Popups.push_back(CPopupWnd(g_hInstance, pSec));
		pSec += lstrlen(pSec) + 1;
	}
	if (!nCount) {
		nCount++;
		g_Popups.push_back(CPopupWnd(g_hInstance));
	}

	return nCount;
}
