// PopupWnd.h: CPopupWnd NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OPTION_H__EE4025E8_695A_4EC0_80A0_7939CB92AF79__INCLUDED_)
#define AFX_OPTION_H__EE4025E8_695A_4EC0_80A0_7939CB92AF79__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"

#define MAX_SECTION 256
#define MAX_FONTNAME 256

#define VIEWMODE_EDIT			1
#define VIEWMODE_BROWSER		2

#define ANIMATIONMODE_NONE		0
#define ANIMATIONMODE_FADEIN	1

ATOM PopupWndRegisterClass(HINSTANCE);

class CPopupWnd
{
public:
	CPopupWnd(HINSTANCE);
	CPopupWnd(HINSTANCE, LPCSTR);
	virtual ~CPopupWnd();

	BOOL Show(int, BOOL);
	void Refresh(void);
	void Close(BOOL);
	void StartCloseTimer(void);
	LPCSTR GetTitle(LPSTR);
	HWND GethWnd(void);
	BOOL CheckChanged(void);

public:
	LRESULT WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
	LRESULT SubWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

private: //Cxgnh
	BOOL OnCreate(HWND hWnd, LPCREATESTRUCT lpCreateStruct);
	void OnActivate(HWND hWnd, UINT state, HWND hWndActDeact, BOOL fMinimized);
	void OnActivateApp(HWND hWnd, BOOL fActivate, DWORD dwThreadId);
	void OnSize(HWND hWnd, UINT state, int cx, int cy);
	HBRUSH OnCtlColor(HWND hWnd, HDC hDC, HWND hWndChild, int type);
	void OnCommand(HWND hWnd, int id, HWND hwndCtl, UINT codeNotify);
	void OnKey(HWND hWnd, UINT vk, BOOL fDown, int cRepeat, UINT flags);
	void OnTimer(HWND hWnd, UINT id);
	void OnDestroy(HWND hWnd);
	void OnRefreshText(HWND hWnd);


private:
	void Init(HINSTANCE, LPCSTR);
	void LoadSetting(LPCSTR);
	void SaveSetting(void);

private:
	HINSTANCE m_hInstance;
	HWND m_hWnd;
	HWND m_hEdit;
	WNDPROC m_hEditPrevWndProc;
	DWORD m_CloseTime;
	CComQIPtr<IWebBrowser2>	m_IE;
	HFONT m_hFont;
	HBRUSH m_hBkBrush;
	FILETIME m_ViewFileTime;
	BOOL m_fNeedSave;

	//ݒl
	char m_SectionName[MAX_SECTION];
	char m_Title[MAX_SECTION];
	char m_ViewFileName[MAX_PATH];
	int m_ViewMode;
	RECT m_Rect;
	int m_ViewTime;
	BOOL m_ChangeNotify;
	char m_FontName[MAX_FONTNAME];
	int m_FontSize;
	COLORREF m_TextColor;
	COLORREF m_BkColor;
	int m_AnimationMode;
	int m_AnimationSpeed;
};

#endif // !defined(AFX_OPTION_H__EE4025E8_695A_4EC0_80A0_7939CB92AF79__INCLUDED_)

